 /*****************************************************************************
 * CDD v1.0 Copyright (C) 1996, Charles R. Henrich, All Rights Reserved.      *
 *                                                                            *
 * Use in source and binary forms, with or without modification and           *
 * Redistribution without modification are permitted provided that the        *
 * following conditions are met:                                              *
 *                                                                            *
 * 1. Redistributions of source code must retain the above copyright          *
 *    notice, all internal copyright notices, this list of conditions         *
 *    and the following disclaimer.                                           *
 * 2. Redistributions in binary form must reproduce the above copyright       *
 *    notice, this list of conditions and the following disclaimer in the     *
 *    documentation and/or other materials provided with the distribution.    *
 * 3. All advertising materials mentioning features or use of this software   *
 *    must display the following acknowledgement:                             *
 *      CDD Was developed in 1996 by Charles Henrich                          *
 * 4. Neither the name of this product (CDD) nor the name of the author       *
 *    (Charles Henrich) may be used to endorse products that include this     *
 *    product without specific prior written permission.                      *
 * 5. No profit may be made from the inclusion, or distribution of this       *
 *    product.  Although a reasonable service charge for the distribution     *
 *    of this product is permitted where appropriate.                         *
 *                                                                            *
 * THIS SOFTWARE IS PROVIDED BY CHARLES HENRICH `` AS IS '' AND ANY EXPRESS   *
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED          *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE     *
 * DISCLAIMED.  IN NO EVENT SHALL CHARLES HENRICH BE LIABLE FOR ANY DIRECT,   *
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES         *
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR         *
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)         *
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT *
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY  *
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF     *
 * SUCH DAMAGE.                                                               *
 *                                                                            *
 ******************************************************************************
 *                                                                            *
 * Email: henrich@msu.edu                                                     *
 *                                                                            *
 *****************************************************************************/

#define SUCCESS (1==1)
#define FAILURE (1==0)
#define TRUE SUCCESS
#define FALSE FAILURE

#define VERSION "1.0-961116"

#define TOCENTRYSIZE 8
#define MAXTOCSIZE 4+8*100 
#define MAXTOCENTRIES 100
#define FRAMESPERREAD 25 
#if 1
#define READOVERLAP 0
#else
#define READOVERLAP 1
#endif
#define L1OVERLAPBYTES 300 
#define L2OVERLAPBYTES L1OVERLAPBYTES*2
#define MINBYTEOVERLAP 200 
#if 1
#define AUDIOSTARTOFFSET 0
#else
#define AUDIOSTARTOFFSET -15
#endif
#define CDDATAFRAMESIZE 2048
#define CDRAWFRAMESIZE 2352
#define CDDAFRAMESIZE 2352
#define CDPABSIZE 2368
#define CDDATAREADSIZE CDDATAFRAMESIZE*FRAMESPERREAD
#define CDAUDIOREADSIZE CDRAWFRAMESIZE*FRAMESPERREAD
#define CDRAWREADSIZE CDRAWFRAMESIZE*FRAMESPERREAD

#define PRINT(a,x,y,z) {if(a == 0) cdd_printf(x, y); else cdd_printf(x,z);}

typedef struct commandops
    {
    char workdir[MAXPATHLEN];
    int onlyaudio;
    int onlydata;
    int track;
    int rawmode;
    int rawmodecorrect;
    int playaudio;
    int bequiet;
    int dostdout;
    int cddb;
    } OPTS;

typedef struct tocentry
    {
    int   preemph;
    int   dcp;
    int   ttype;
    int   nchan;
    int   tracknumber;
    int   absaddr;
    int   absendaddr;
    char  trackname[BUFSIZ];
    } CDTOCENT;

typedef struct toc
    {
    int toclen;
    int firsttrack;
    int lasttrack;
    int numentries;
    CDTOCENT tocents[MAXTOCENTRIES];
    char cdname[BUFSIZ];
    } CDTOC; 
    
typedef struct bcdnumber
    {
    u_char lsd:4;       
    u_char msd:4;
    } BCD;

typedef struct audiosubcodes
    {
    u_int control:4;
    u_int adr:4;
    BCD   track;
    BCD   index;
    BCD   min;
    BCD   sec;
    BCD   frame;
    BCD   unused;
    BCD   amin;
    BCD   asec;
    BCD   aframe;
    char  pad[6];
    } ASUB;

typedef struct plextor_audio_block
    {
    char data[CDRAWFRAMESIZE];
    ASUB sub;
    } PAB;

extern OPTS G_opts;

void resetcd(int signo);
void showcdtoc(CDTOC *cdtoc);      
void copycdtoc(CDTOC *cdtoc, OPTS *opts);
void copycddata_to_file(CDTOCENT *cdtocent, char *filename, OPTS *opts);
void copyrawcddata_to_file(CDTOCENT *cdtocent, char *filename, OPTS *opts);
void copycdaudio_to_cda(CDTOCENT *cdtocent, char *filename, OPTS *opts);

#undef SCSIREQ_ERROR

/* || SR->status        */ /* Host adapter status */ 

#define SCSIREQ_ERROR(SR) (\
0 \
|| SR->senselen_used    /* Sent sense */ \
|| SR->retsts           /* SCSI transfer status */ \
|| SR->error            /* copy of errno */ \
)
