 /*****************************************************************************
 * CDD v1.0 Copyright (C) 1996, Charles R. Henrich, All Rights Reserved.      *
 *                                                                            *
 * Use in source and binary forms, with or without modification and           *
 * Redistribution without modification are permitted provided that the        *
 * following conditions are met:                                              *
 *                                                                            *
 * 1. Redistributions of source code must retain the above copyright          *
 *    notice, all internal copyright notices, this list of conditions         *
 *    and the following disclaimer.                                           *
 * 2. Redistributions in binary form must reproduce the above copyright       *
 *    notice, this list of conditions and the following disclaimer in the     *
 *    documentation and/or other materials provided with the distribution.    *
 * 3. All advertising materials mentioning features or use of this software   *
 *    must display the following acknowledgement:                             *
 *      CDD was developed in 1996 by Charles Henrich                          *
 * 4. Neither the name of this product (CDD) nor the name of the author       *
 *    (Charles Henrich) may be used to endorse products that include this     *
 *    product without specific prior written permission.                      *
 * 5. No profit may be made from the inclusion, or distribution of this       *
 *    product.  Although a reasonable service charge for the distribution     *
 *    of this product is permitted where appropriate.                         *
 *                                                                            *
 * THIS SOFTWARE IS PROVIDED BY CHARLES HENRICH `` AS IS '' AND ANY EXPRESS   *
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED          *
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE     *
 * DISCLAIMED.  IN NO EVENT SHALL CHARLES HENRICH BE LIABLE FOR ANY DIRECT,   *
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES         *
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR         *
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)         *
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT *
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY  *
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF     *
 * SUCH DAMAGE.                                                               *
 *                                                                            *
 ******************************************************************************
 *                                                                            *
 * Email: henrich@msu.edu                                                     *
 *                                                                            *
 *****************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "cdd.h"
#include "cdd_util.h"

int bcdtodec(BCD *value)
{
return (value->msd * 10 + value->lsd);
}

void printmsf(int absaddr)
{
u_int min;
u_int sec;
u_int frame;

absaddr += 150; 

min = absaddr / 4500;
sec = (absaddr - (min * 4500)) / 75;
frame = absaddr - (min * 4500 + sec * 75);

cdd_printf("%02u:%02u:%02u", min, sec, frame);
}

void cdd_printf(char *fmt, ...)
{
va_list ap;

if(G_opts.bequiet == TRUE) return;

va_start(ap, fmt);
vprintf(fmt, ap);
va_end(ap);
}

/****************************************************************************/
/* Function: split                            * Author : Charles Henrich    */
/*                                            * Date   : January 2, 1995    */
/*                                            *******************************/
/*                                                                          */
/* Calling Parameters: A string, a array of points, and a character         */
/*                                                                          */
/* Return codes: The number of elements broken out of the string            */
/*                                                                          */
/* Purpose: This routine takes a string delimited by the passed in          */
/*          seperator character, and breaks it into many smaller strings    */
/*                                                                          */
/****************************************************************************/
/*      Copyright (c)1995 Michigan State University Board of Trustee's      */
/****************************************************************************/

int split(char *base, char *array[], char seperator)
{
int arraypos;
int count;
char *startptr;
char *endptr;

if(base == NULL) return 0;

startptr = base;

for(count=0,arraypos=0;
   (endptr = (char *)strchr(startptr,seperator)) != NULL;
    count++,arraypos++)
    {
    *endptr = '\0';

    array[arraypos] = startptr;

    endptr++;

    startptr = endptr;
    }

array[arraypos] = startptr;

return count+1;
}

