#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <soundcard.h>

int main(int argc, char *argv[])
{
int audio_fd;
int sound_fd;
int precision;
int stereo;
int speed;
char buffer[BUFSIZ];
int ret;
int wret;

if(argc != 5)
    {
    fprintf(stderr,"Usage: %s ##bits [0=mono|1=stereo] ##hz filename\n",
            argv[0]);
    exit(0);
    }

precision = atoi(argv[1]);
stereo = atoi(argv[2]);
speed = atoi(argv[3]);

if ((audio_fd = open ("/dev/dsp", O_WRONLY, 0)) < 0)
    {
    fprintf(stderr,"Unable to open audio device\n");
    exit(0);
    }

 
if(ioctl(audio_fd, SNDCTL_DSP_SAMPLESIZE, &precision) == -1 ||
      ioctl(audio_fd, SNDCTL_DSP_STEREO, &stereo) == -1 ||
      ioctl(audio_fd, SNDCTL_DSP_SPEED, &speed) == -1)
    {
    perror ("configuration of /dev/dsp failed");
    close(audio_fd);
    exit(0);
    }

if ((sound_fd = open (argv[4], O_RDONLY, 0)) < 0)
    {
    fprintf(stderr,"Unable to open %s\n", argv[4]);
    close(audio_fd);
    exit(0);
    }

while((ret=read(sound_fd, buffer, BUFSIZ)) > 0)
    {
    if(ret < 0) 
        {
        fprintf(stderr,"Unable to read from %s\n",argv[4]);
        close(audio_fd);
        close(sound_fd);
        exit(0);
        }

    wret=write(audio_fd, buffer, ret);
    if(wret != ret) 
        {
        if(wret < 0) 
            {
            fprintf(stderr,"Unable to write to audio device!\n");
            close(audio_fd);
            close(sound_fd);
            exit(0);
            }
        }

    ret-=wret;
    }

close(audio_fd);
close(sound_fd);
exit(0);
}
