/****************************************************************************/
/*                                                                          */
/* These routines were written by Charles Henrich                           */
/*                                                                          */
/* Copyright (c) 1993 Michigan State University Board of Trustee's          */
/*                                                                          */
/****************************************************************************/

typedef void (*CBACK_FUNC)(SOCK *);                /* Pointer to a function */

#define BUF_SIZE             BUFSIZ
#define NUM_CBACKS           6
#define ERROR_TABLE_SIZE     16

 /**************************************/
 /*                                    */
 /* Private routine declarations.      */
 /*                                    */
 /**************************************/

static int reset_input_descriptors(void);
static int input_handler(int descriptor);
static int initialize_new_connection(int descriptor);
static int get_ready_descriptors(fd_set *readfds, int ready_descriptors[]);
static void do_callback(int callback, int descriptor);
static void close_connection(int descriptor);
static int sock_write(int descriptor, char *string);
static int sock_read(int descriptor, char *string, int bufsize);
