#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

#define BUFSIZE 150*2352

int main(int argc, char *argv[])
{
unsigned int input;
unsigned char buffer[BUFSIZE];
int ret;
long pos;
int count;
FILE *ofp;
FILE *ifp;

if(argc == 1)
    {
    fprintf(stderr,"Usage: %s filename\n", argv[0]);
    exit(0);
    }

ifp=fopen(argv[1],"r");

if(ifp == NULL)
    {
    fprintf(stderr,"cant open file\n");
    exit(0);
    }

ofp=fopen("stripfile","w");

if(ofp == NULL)
    {
    fprintf(stderr,"cant open strip file\n");
    exit(0);
    }

while((input = fgetc(ifp)) == 0) continue;

fputc(input, ofp);

while((input = fgetc(ifp)) != EOF) fputc(input, ofp);

fclose(ifp);
fclose(ofp);

rename("stripfile", argv[1]);

ifp=fopen(argv[1],"r+");

if(ifp == NULL)
    {
    fprintf(stderr,"cant open file\n");
    exit(0);
    }

ret=fseek(ifp, -BUFSIZE, SEEK_END);

if(ret == -1)
    {
    fprintf(stderr,"Cant seek from end.\n");
    exit(0);
    }

pos = ftell(ifp);

bzero(buffer, BUFSIZE);
ret=fread(buffer, 1, BUFSIZE, ifp);

if(ret == 0 && (feof(ifp) != 0 || ferror(ifp) != 0))
    {
    fprintf(stderr,"Cant read to end\n");
    exit(0);
    }

for(count=BUFSIZE-1;count>=0;count--)
    {
    if(buffer[count] == 0) continue;
 
    printf("Nonzero char found at %lu:%d\n", pos+count, count);
    break;
    }

ret=ftruncate(fileno(ifp), pos+count+1);

if(ret != 0)
    {
    perror("FTruncate");
    }

printf("Done\n");
exit(0);
}
